unit TransparentesFenster;

interface

uses
  Windows, Graphics;

type
 TSetLayeredWindowAttributes = function (
  hwnd : HWND;         // handle to the layered window
  crKey : TColor;      // specifies the color key
  bAlpha : byte;       // value for the blend function
  dwFlags : DWORD      // action
 ): BOOL; stdcall;
 function SetWindowTransparency(Grad: byte; Ziel: THandle) : Boolean;
 function ClearWindowTransparency(Ziel: THandle) : Boolean;

const
 WS_EX_LAYERED = $80000;
 LWA_COLORKEY = 1;
 LWA_ALPHA    = 2;

var
 AHandle: THandle;
 AValue : byte = 255;

implementation

function SetWindowTransparency (Grad: byte; Ziel: THandle) : Boolean;
var
 Info: TOSVersionInfo;
 SetLayeredWindowAttributes: TSetLayeredWindowAttributes;
begin
 AHandle := Ziel;
 AValue := Grad;
 Info.dwOSVersionInfoSize := SizeOf(Info);
 GetVersionEx(Info);
 if (Info.dwPlatformId = VER_PLATFORM_WIN32_NT) and
 (Info.dwMajorVersion >= 5) then begin
  SetLayeredWindowAttributes := GetProcAddress(GetModulehandle(user32),
  'SetLayeredWindowAttributes');
  if Assigned(SetLayeredWindowAttributes) then begin
   SetWindowLong(AHandle, GWL_EXSTYLE, GetWindowLong(AHandle, GWL_EXSTYLE) or
   WS_EX_LAYERED);
   SetLayeredWindowAttributes(AHandle, 0, AValue, LWA_ALPHA);
   Result := true;
  end;
 end else Result := false;
end;

function ClearWindowTransparency (Ziel: THandle) : Boolean;
var
 Info: TOSVersionInfo;
begin
 Result := false;
 Info.dwOSVersionInfoSize := SizeOf(Info);
 GetVersionEx(Info);
 if (Info.dwPlatformId = VER_PLATFORM_WIN32_NT) and
  (Info.dwMajorVersion >= 5) then
  SetWindowLong(Ziel, GWL_EXSTYLE, GetWindowLong(Ziel, GWL_EXSTYLE) and
  not WS_EX_LAYERED);
 Result := true;
end;

end.
